/*
change le format des tables d'ondes 4x pour les patch de OK
i.e.: le debut de l'echantillon est situe au milieu de la table

ce programme prend un table venant de Sampler88 ou du VAX, et reecrit
une nouvelle table commancant au milieu
Pour une table de 64K, on a 131072 bytes
milieu=65536
*/


#include <stdio.h>
#include <sys/file.h>
#define TAILLE 131072
#define MILIEU 65536

short isam[TAILLE];

main(argc, argv)
 int argc;
 char *argv[];
{
  int fi,fo;
  int i,j, k,ib;
  int pos;
  float f;

	if ((fi = open(argv[1],O_RDONLY)) < 0)
	   {
	   printf("peut pas lire, salut!\n"); 
	   printf(" Usage: inv_wt FILIN FILOUT\n");
	   exit(0);
	   }
	if ((fo = open(argv[2],O_CREAT|O_WRONLY, 0666)) < 0)
	   {
	   printf("peut pas creer, salut\n"); 
	   printf(" Usage: inv_wt FILIN FILOUT\n");
	   exit(0);
	   }

/* lire la 2nd moitie de filin, la placer dans 1ere moitie de filout */
	pos = lseek(fi, MILIEU, 0);
	pos = lseek(fo, 0, 0);
	read(fi, isam, MILIEU);
	write(fo, isam, MILIEU);

/* et vice versa */
	pos = lseek(fi, 0, 0);
	pos = lseek(fo, MILIEU, 0);
	read(fi, isam, MILIEU);
	write(fo, isam, MILIEU);

	close(fi);
	close(fo);
}
