#include <math.h>
#include <stdio.h>
#include <signal.h>
#include <sys/file.h>
#define K       1024
#define NORMA   32767
enum MODE       {SYNTHESE_ADD,BREAK_POINT};

        float Y[64*K];   
        short X[64*K];
        unsigned i, nb_points = 4096, n1, n2;
	float n=0;
        /*FILE *fp;*/
	int fp;
        float a, phi, pi2, a1, a2;
	float amp = 1;

main(ac,av)
        int ac;
        char **av;
{
if (!strcmp(av[1], "-n"))
{
	ac -= 2;
	av += 2;
	if (ac < 1 || sscanf(av[0], "%f", &amp) < 1)
	{
		fprintf(stderr, "bad amplitude\n");
		exit(1);
	}
}
if (ac < 2)  {printf("usage : mksin4K file (salut...)\n");
		return(0);} 

                synadd(av[1]);
}
	


synadd(name) 
char *name;
{ 
        printf( "          ***SYNTHESE ADDITIVE DE FONCTIONS***\n\n");
        pi2=8*atan(1.);

/* saisie des donnees
           numero d'harmonique
           son amplitude (lineaire)
           sa phase (en radians)             */

        printf("  Num.   Amplitude    Phase(radians)\n");
while(scanf("%f %f %f",&n,&a,&phi) == 3)        
        {
	printf("%f %f %f\n",n,a,phi);
         for (i=0; i<nb_points; i++)
              Y[i] = a * sin (pi2 * n * i /(float) nb_points + phi) + Y[i];
        }
	printf("on normalise...\n");
        normalise();

/* ecriture du fichier fich contenant les valeurs sur 16 bits 
              a charger sur 4X            */
	printf("on ecrit dans le fichier %s\n", name);
        /*fp=fopen (name,"w");
        fwrite( X , sizeof(*X) , nb_points , fp);
        fclose(fp);*/
        fp=open(name,O_WRONLY | O_CREAT, 0644);
        write(fp, X , 4*K*sizeof(short));
        close(fp);

}



/*                  normalisation                  */
normalise()       
{
        float max=0;

        for (i=0; i<nb_points; i++) if(max < fabs(Y[i])) max= fabs(Y[i]);
	printf("max = %f\n",max);

        for (i=0 ; i<nb_points ; i++)
        {
                if(Y[i] > 0)
                        X[i]= NORMA * amp * (Y[i] / max) + 0.5;
                else
                        X[i]= NORMA * amp * (Y[i] / max) - 0.5;
        }
}

