/* NInterpol3.c */
#include <math.h>
#include <stdio.h>
#include <sys/file.h>
int duree[1024],longueur[1024],time[1025],coeff[1024];
int ury,i,ii,k,pas,kmax,total;
float resultat[500][72];
float duree_debut[72];
float duree_fin[72];
float indices[72];
float cpt;
float coeff_debut[1024];
float freq[72];
float rapport[72];
float rapport_fin[72];
float echelle[72][72];
float rapport2[72][72];
int pattern[72][72];
char filename[80];
char datafile[80];
#define LONGUEUR_MAX 2000
#define NB_OSC_LECT 32

main(argc,argv)
int argc;
char *argv[];
{
char symb,symb2;
int h,j,l,m,nb_elements,nb_echelles,ind_base,nb_seq;
float n_coupures,freq_inf,freq_sup,freq_inf_fin,freq_sup_fin,div,ind,rapp,
rapp_fin,ind_fin,ind_base_fix;
int save[2];
int longue,time_clic,fd;

FILE *fp;

if (argc != 4){
	printf("Usage: np (duration-file) (output-file) (binary-coeffs)\n");
	exit (0);
	}

	{
		printf("Chargez !.......\n");
		if ((fd = open(argv[3],0)) < 0)
	  	{
	  		fprintf(stderr,"can't open file\n");
	  		return;
	  	}
		if ((read(fd,&kmax,sizeof(int))) != sizeof(int))
	  	{
	  		fprintf(stderr,"read error kmax %x\n",kmax);
	  		close(fd);
	  		exit(1);
	  	}
		if ((read(fd,&ury,sizeof(int))) != sizeof(int))
	  	{
	  		fprintf(stderr,"read error ury %x\n",ury);
	  		close(fd);
	  		exit(1);
	  	}
		if ((read(fd,(char *)duree,kmax * sizeof(int))) 
	   		!= kmax * sizeof(int))
	  	{
	  		fprintf(stderr,"read error duree\n");
	  		close(fd);
	  		exit(1);
	  	}
		if ((read(fd,(char *)longueur,kmax * sizeof(int))) 
	   		!= kmax * sizeof(int))
	  	{
	  		fprintf(stderr,"read error longueur\n");
	  		close(fd);
	  		exit(1);
	  	}
		if ((read(fd,(char *)coeff,kmax * sizeof(int))) 
	   		!= kmax * sizeof(int))
	  	{
	  		fprintf(stderr,"read error coeff\n");
	  		close(fd);
	  		exit(1);
	  	}
		close(fd);
		printf("ok\n");
	}

if ((fp=fopen (argv[1],"r")) == NULL){
	printf("ERR: le fichier %s n'existe pas\n",argv[1]);
	exit(0);
	}

fscanf(fp,"%f",&n_coupures);
				/*printf("%f\n",n_coupures);*/
k = 0;

fscanf(fp,"%d",&nb_seq);
				/*printf("%d\n",nb_seq);*/
for (h=1; h<nb_seq+1; h++)
{	
	fscanf(fp,"%d",&nb_elements);
				/*printf("%d\n",nb_elements);*/
	

	fscanf(fp,"%d",&nb_echelles);
				/*printf("%d\n",nb_echelles);*/

	for (i=0; i<nb_echelles+1; i++)
		{
		for (j=0; j<nb_elements; j++)
			fscanf(fp,"%d",&pattern[i][j]);
		}

/*	for (i=0; i<nb_echelles+1; i++)
		{
		for (j=0; j<nb_elements; j++)
	printf("pattern[%d][%d] = %d\n",i,j,pattern[i][j]);	
	}*/

	fscanf(fp,"%f",&freq_inf);
	fscanf(fp,"%f",&freq_sup);
	fscanf(fp,"%f",&freq_inf_fin);
	fscanf(fp,"%f",&freq_sup_fin);
	fscanf(fp,"%d",&ind_base);

fscanf(fp,"%d",&ury);
/*printf("%d\n",ury);*/

for(i=0;i < ury;i++)
  fscanf(fp,"%f",&duree_debut[i]);
	  /*printf("duree-debut[%d]= %f\n",i,duree_debut[i]);}*/
for(i=0;i < ury;i++)
  fscanf(fp,"%f",&duree_fin[i]);
	  /*printf("duree-fin[%d]= %f\n",i,duree_fin[i]);}*/
fscanf(fp,"%d",&pas);
pas = pas+1;
				/*printf("%d\n",pas);*/
/*---------definition de l'indice pour le calcul des retards-----*/
for(i=0;i<ury;i++)
	indices[i] = (duree_fin[i] - duree_debut[i]) / (float)pas;

/*----------calcul des indices pour les retards----------------*/
m = 0;
for(i=0;i<pas+1;i++)
{
	for(ii=0;ii<ury;ii++)
	{
		resultat[i][ii] = duree_debut[ii] + i * indices[ii];
/*		printf("resultat[%d][%d] = %f\n",i,ii,resultat[i][ii]);*/
		/* convertis en ms et en entiers pour la 4x */
		duree[k] = (int)(1000. * resultat[i][ii]);
		m++;
		/* position de la note suivante              */
		time[k+1] = time[k] + duree[k];

		/* par defaut la longueur vaut 2 s divise par le coeff */
		longueur[k] = (int)((float)LONGUEUR_MAX/coeff_debut[ii]);

		/* protection contre le ratrapage du pointeur d'ecriture*/
		if (k<1) longueur[k] = longueur[k];
		else
		  {
		  if(coeff_debut[ii]>1.)
		   {
		   time_clic = (int)((float)time[k] / (coeff_debut[ii] - 1.));
		   longueur[k] = 
		   time_clic < longueur[k] ?
		   time_clic : longueur[k] ;
		   }
		  }
/*printf("time_clic = %d\n",time_clic);
printf("longueur[%d] = %d  coeff[%d] = %f\n",k,longueur[k],ii,coeff_debut[ii]);*/
		/* racourcissement de la note dont on prendra */
		/* l'oscillateur                              */
		if(k>=NB_OSC_LECT) 
			{
			longue = time[k] - time[k-NB_OSC_LECT];
			longueur[k-NB_OSC_LECT] = 
			longue < longueur[k-NB_OSC_LECT] ?
			longue : longueur[k-NB_OSC_LECT];
			}
		k++;
	}
     }
}

kmax = k;
fclose(fp);

if ((fd = open(argv[2],O_WRONLY | O_CREAT, 0644)) < 0)
  {
  fprintf(stderr,"can't open file\n");
  exit(1);
  }
save[0] = kmax;
if (write(fd,(char *)save,sizeof(int)) < 0)
  {
  fprintf(stderr,"error writing file\n");
  exit(1);
  }
save[0] = ury;
if (write(fd,(char *)save,sizeof(int)) < 0)
  {
  fprintf(stderr,"error writing file\n");
  exit(1);
  }
if (write(fd,(char *)duree,kmax * sizeof(int)) < 0)
  {
  fprintf(stderr,"error writing file\n");
  exit(1);
  }
if (write(fd,(char *)longueur,kmax * sizeof(int)) < 0)
  {
  fprintf(stderr,"error writing file\n");
  exit(1);
  }
if (write(fd,(char *)coeff,kmax * sizeof(int)) < 0)
  {
  fprintf(stderr,"error writing file\n");
  exit(1);
  }
close(fd);
}
