/*******************   chapo **********************************/
/********  creation du fichier d'enveloppe spectrale  *********/
#include <stdio.h>
#include <sys/file.h>
#define TAILLE 16384
#define NB_RAIES 4
short tab[TAILLE];
int pic[NB_RAIES]={4096,2048,1024,512};
int jupe = 64,dist_harm = 128;
main(argc,argv)
int argc;
char *argv[];
{
int size;
int j,j1,j2,raie;
int fd;

if (argc < 2)  {printf("usage : gen_s_env datafile (salut...)\n");
		return(0);} 

if ((fd=open(argv[1],O_CREAT|O_WRONLY, 0666)) < 0)
{	printf("Peut pas creer fichier\n");
	exit(4);
}

/*******  on calcule les points de la courbe *******/
for(raie=0;raie<=NB_RAIES;raie++)
	{
	for(j=0;j<jupe;j++)
		{
		j1 = ((dist_harm * raie) - j);
		if(j1<0) j1 += TAILLE;
		j2 = ((dist_harm * raie) + j);
		tab[j1] = ((jupe - j) * pic[raie])/jupe;
		tab[j2] = tab[j1];
		if (tab[j1] != 0)
		printf("tab[%d]=tab[%d]=%d\n",j1,j2,tab[j1]);
		}
	}
/*******  on ecrit sur le disque *******/
size = TAILLE * 4;
if (write(fd, tab, sizeof(tab)) != sizeof (tab))
	perror("Erreur d'ecriture");
close(fd);
}
