#include <math.h>
#include <stdio.h>
#include <sys/file.h>
char filename[80];
char datafile[80];
int n_freq, n_partiels, fd, kmax;
float freq[28],freq_bis[28];
float part_pos[28][28],part_neg[28][28],partiels[28][28];
main(argc, argv)
 char **argv;
{
int i, j, k, l, m, tata;
int toto,x;
int save[2];

FILE *fp;
 if (argc < 3) 
 {
	printf("no args?\n");
	exit(1);
  }
fp = fopen(argv[1],"r");

fscanf(fp,"%d",&n_freq);
fscanf(fp,"%d",&n_partiels);

/****  les tableaux freq et freq_bis sont convertis en entiers  et *****/
/****  en quart de Hz afin d'ameliorer la precision pour les entiers ***/

for (i=0; i<n_freq; i++)
    {
	fscanf(fp,"%f",&freq[i]);
	freq_bis[i] = freq[i];
printf("freq[%d] = %f\n",i,freq[i]);
    }
k=0;

/***** part_pos recoit le resultat de a + nb part_neg de a - nb *****/
/***** les frequences negatives deviennent positives et sont    *****/
/***** annulees les frequences apparaissant une 2eme fois       *****/

for (i=0; i<n_freq; i++)
    {
    fscanf(fp,"%f",&freq[i]);
    for (j=0; j<n_freq; j++)
	{
	for (l=0; l<n_partiels/2; l++)
	    {
	    toto = (l+1) * freq[j];
            part_pos[k][l] = freq[i] + toto;
	    /* printf("part_pos[%d][%d] = %f\n", k, l, part_pos[k][l]);*/
	    }
       	    for (l=0; l<n_partiels/2; l++)
	      {
	      toto = (l+1) * freq[j];
              x = freq[i] - toto;
              part_neg[k][l] = (x<0.0? -x : x);
	      /* printf("part_neg[%d][%d] = %f\n", k, l, part_neg[k][l]);*/
	      for (m=0; m<n_partiels/2; m++)
	    	{
      	    	if (part_neg[k][l] == part_pos[k][m])
	    			  part_neg[k][l] = 0.0;
		}
              }				     
	k = k+1;
	}
    
     }
/*** kmax est le nombre de spectre maximum deduit du nombre de frequences ***/
/*** donne' dans le fichier d'entree.					  ***/
kmax = k;

for (i=0; i< kmax; i++)
    {
     k=0;
     l=1;
     for (j=0; j<(n_partiels/2); j++)
	{
	 partiels[i][k] = part_neg[i][j];
	 partiels[i][l] = part_pos[i][j];
/*         printf("part_pos[%d][%d] = %d part_neg[%d][%d] = %d\n",
				i,j,part_pos[i][j],i,j,part_neg[i][j]);*/
         k=k+2;
	 l=l+2;
        }
    }
fclose(fp);
if (!(fp = fopen(argv[2], "w"))) printf("can't open it\n");

for (i=0; i<kmax; i++)
    {
     for (j=0; j<n_partiels; j++)
	{
	 fprintf(fp, "C %d %f\n",j,partiels[i][j]);
        }
     fprintf(fp, "\n");
    }

fclose(fp);
}

