/***********************************************************
cq.c - Construction des fichiers de qlist pour Max.

Codes generaux
--------------

*****************************************************************/

#include <math.h>
#include <stdio.h>
#include <strings.h>
#define CONST 0x1000000
#define FOREVER for(;;)
#define RATTEMP 680

main(argc,argv)
int argc;
char *argv[];
{
	float xeti;
	int sectionnum;
	int f, ilun, iosc;
	int i, j, n, n1, n2;
	int c, E, num1, num2;
	int P	 = 10;
	int B_flag	 = 0;
	int sin_flag	 = 0;
	int sin_flag2	 = 0;
	int icpt	 = 0;
	int seqnum 	= 0;
	char *seqname = "sin";
	int funpla = 0;
	char funname[80];
	int chapo = 0;

	int Mcod[10];
	char nstr[10];			/* input string */
	char sinfile[20];		/* input sin file name */
	char sCP[15];
	char sQl[15];

	FILE *fi;
	FILE *fo;
	int recordit = 0, playit = 0, rattrap = 0;

	argv++ ; argc--;
	while (**argv == '-')
	{
		if (!strcmp(*argv, "-r")) recordit = 1;
		else if (!strcmp(*argv, "-p")) playit = 1;
		argv++; argc--;
	}
/* check command string : PROG filin filout  (3 arguments) */
	if (argc != 2){
		printf("Usage: PROG filin filout \n");
		exit(0);
		}
/* test sur filin: existe? si oui, ouvrir, sinon exit */
	if ((fi=fopen (argv[0],"r"))==NULL){
		printf("ERR: le fichier %s n'existe pas\n",argv[0]);
		exit(0);
		}
/* ouvrir fichier de sortie */ fo=fopen(argv[1],"w");

/***********************************************************************/

FOREVER 
{
fscanf(fi,"%s",nstr);

if (nstr[0] == 'B')
	{
	fprintf(fo,"! %s\n",argv[1]);	/* print qlist name */
	fscanf(fi,"%s",sCP);	/* lire nom du CP (ex: upd4x2) */
	fscanf(fi,"%s",sQl);	/* lire nom du Qlist (ex: qlist2) */
	fscanf(fi,"%d",&E);	/* lire etiquette debut */

	/* lire le/les codes MIDI; finir par un 0 */
	i=0;
	fscanf(fi,"%d",&Mcod[0]);
	while (Mcod[i] != 0) 	
		{
		i++;
		fscanf(fi,"%d",&Mcod[i]);
		}
	if (fscanf(fi,"%d",&sectionnum) < 1) hate("no section number\n");;

	fprintf(fo,"%d 0%d000 %s stop ;\n",E,E,sQl);

	E=E+5;
fprintf(fo,"\n0%d 00%d000 %s start 0 1 ;\n",E,E,sCP);
fprintf(fo,"0%d 00%d050 notegroup1 start ;\n",E,E);
fprintf(fo,"0%d 00%d050 flute start ;\n",E,E);
fprintf(fo,"0%d 00%d050 trigger1 start ;\n",E,E);
fprintf(fo,"0%d 00%d050 trigger1 set %s start %d %d ;\n",E,E,sQl,E+5,E+6);
fprintf(fo,"0%d 00%d050 notegroup1 set ",E,E);
	/* impr. codes MIDI */
	for (j=0; j<i; j++)
		fprintf(fo," %d ",Mcod[j]);
fprintf(fo,";\n");
/* load a function table (plaque is funpla; name is funname) */
	if (funpla)
		{
	fprintf(fo,"%d %d 4x ldfun %s %d 64K1 ;\n",E,E*1000+50,funname,funpla);
		funpla = 0;
		}

/* pour sin : 
	si sin_flag=1, recorddeb
	si sin_flag2=1 chargez
*/

/* cas 1: chargez seulement */
	if (sin_flag ==  0 && sin_flag2 == 1)
		{
	fprintf(fo,"0%d 00%d050 sin sequence %d ;\n",E,E,seqnum);
	fprintf(fo,"0%d 00%d050 sin chargez ",E,E);
	fprintf(fo,"Interpol/%s ;\n",sinfile);
		sin_flag2 = 0;
		}

/* cas 2: init record et chargez */
	if (sin_flag == 1)
		{
	fprintf(fo,"0%d 00%d050 sin newrhythm ;\n",E,E);

		if (sin_flag2 ==  1)
			{
	fprintf(fo,"0%d 00%d050 %s sequence %d ;\n",E,E,seqname, seqnum);
	fprintf(fo,"0%d 00%d050 %s chargez ",E,E, seqname);
	fprintf(fo,"Interpol/%s ;\n",sinfile);
			sin_flag2 = 0;
			}

	fprintf(fo,"0%d 00%d050 %s recorddeb %d %d ;\n",E,E,seqname, num1,num2);
		sin_flag = 0; /* RAZ */
		}

fprintf(fo,"0%d 00%d050 trigger95 set trigger1 ok ;\n", E, E);
fprintf(fo,"0%d 00%d050 trigger95 repeat ;\n",E,E);
fprintf(fo,"0%d 00%d050 trigger95 start ;\n",E,E);
fprintf(fo,"0%d 00%d050 triggeru95 stop ;\n",E,E);
fprintf(fo,"0%d 00%d050 foo PART %d ;\n",E,E, sectionnum);
fprintf(fo,"0%d 00%d050 print START_%d ;\n",E,E, sectionnum);
fprintf(fo,"0%d 00%d050 %s stop ;\n",E,E,sQl);
	}

/* r == recorddeb (sin) */
else if (nstr[0] == 'r')
	{
	sin_flag=1;
	fscanf(fi,"%d %d",&num1,&num2);
	}
	
/* f == recorfin (sin) */
else if (nstr[0] == 'f')
	sin_flag=2;

/* + == on incremente de 5 au lieu de 10 */
else if (nstr[0] == '+')
	P=5;
/* = == on incremente de n'importe au lieu de 10 */
else if (nstr[0] == '=')
{
	if (fscanf(fi, "%d", &P) < 1) hate("bad '=' arg");
}

else if (nstr[0] == 'c')
	{
	sin_flag2 = 1;
	fscanf(fi,"%d",&seqnum);
	/* if (seqnum >= 10)
	{
		seqname = "sin2";
		seqnum -= 10;
	}
	else seqname = "sin"; */
	fscanf(fi,"%s",sinfile);
	}
else if (nstr[0] == 'C')
	{
	sin_flag2 = 2;
	fscanf(fi,"%d",&seqnum);
	/* if (seqnum >= 10)
	{
		seqname = "sin2";
		seqnum -= 10;
	}
	else seqname = "sin"; */
	fscanf(fi,"%s",sinfile);
	}
else if (nstr[0] == 'G')	/* go */
	{
	sin_flag2 = 3;
	fscanf(fi,"%d",&seqnum);
	/* if (seqnum >= 10)
	{
		seqname = "sin2";
		seqnum -= 10;
	}
	else seqname = "sin"; */
	}
else if (nstr[0] == 'S')	/* stop */
	{
	sin_flag2 = 4;
	fscanf(fi,"%d",&seqnum);
	/* if (seqnum >= 10)
	{
		seqname = "sin2";
		seqnum -= 10;
	}
	else seqname = "sin"; */
	}
else if (nstr[0] == 'T')	/* continue */
	{
	sin_flag2 = 5;
	fscanf(fi,"%d",&seqnum);
	/* if (seqnum >= 10)
	{
		seqname = "sin2";
		seqnum -= 10;
	}
	else seqname = "sin"; */
	}
else if (nstr[0] == 'F')	/* Function */
	{
	fscanf(fi,"%s%d",funname, &funpla);
	}
else if (nstr[0] == 's')	/* chapo start (1) or stop (2) */
	{
	fscanf(fi,"%d",&chapo);
	}

/* main def */
else if (nstr[0] == 'b')
	{
	int T;
	fscanf(fi,"%d",&E); /* lire etiquette */
	if (playit) 
	{
		fscanf(fi,"%d",&T); /* lire time */
		T += 10000;
	}
	else T = 1000*E;	/* default time is 1000* etiquette */
	/* lire le/les codes MIDI; finir par un 0 */
	i=0;
	fscanf(fi,"%d",&Mcod[0]);
	while (Mcod[i] != 0) 	
		{
		i++;
		fscanf(fi,"%d",&Mcod[i]);
		}

fprintf(fo,"\n%d %d %s start %d %d ;\n",E,T,sCP,E,E+1);

/* start/stop chapo */
	if (chapo == 1)
		{
	fprintf(fo,"%d %d chapo start ;\n",E,T);
		chapo = 0;
		}
	else if (chapo == 2)
		{
	fprintf(fo,"%d %d chapo stop ;\n",E,T+20);
		chapo = 0;
		}
/* pour sin : 
	si sin_flag=1, recorddeb
	si sin_flag=2, recorfin
	si sin_flag2 =1 code c : chargez	(later in the code)
	si sin_flag2 =2 code C : nchargez	(later in the code)
	si sin_flag2 =3 code G : go 
	si sin_flag2 =4 code S : stop
	si sin_flag2 =5 code T : continue
*/
	if (sin_flag2 ==  3)
		{
	fprintf(fo,"%d %d %s sequence %d ;\n",E,T,seqname, seqnum);
	fprintf(fo,"%d %d %s go ;\n",E,T, seqname);
		sin_flag2 = 0;
		}
	else if (sin_flag2 ==  4)
		{
	fprintf(fo,"%d %d %s chute ;\n",E,T, seqname);
		sin_flag2 = 0;
		}
	else if (sin_flag2 ==  5)
		{
	fprintf(fo,"%d %d %s continue ;\n",E,T, seqname);
		sin_flag2 = 0;
		}

	fprintf(fo,"%d %d 4x reset ;\n",E,T+20);

	if (sin_flag2 ==  1)	/* charge */
		{
	fprintf(fo,"%d %d %s sequence %d ;\n",E,T+20,seqname, seqnum);
	fprintf(fo,"%d %d %s chargez ",E,T+20, seqname);
	fprintf(fo,"Interpol/%s ;\n",sinfile);
		sin_flag2 = 0;
		}
	else if (sin_flag2 ==  2)	/* nchargez (for amplitudes) */
		{
	fprintf(fo,"%d %d %s sequence %d ;\n",E,T+20,seqname, seqnum);
	fprintf(fo,"%d %d %s nchargez ",E,T+20, seqname);
	fprintf(fo,"Interpol/%s ;\n",sinfile);
		sin_flag2 = 0;
		}
	if (sin_flag == 1)
		{
	fprintf(fo,"%d %d %s recorddeb %d %d ;\n",E,T+20,seqname,num1,num2);
		sin_flag = 0; /* RAZ */
		}

	else if (sin_flag == 2)
		{
	fprintf(fo,"%d %d %s recordfin ;\n",E,T+20, seqname);
		sin_flag = 0; /* RAZ */
		}

if (rattrap && rattrap > E+P) 
	fprintf(fo,"%d %d trigger1 set %s start %d %d %d ;\n",E,T+20,sQl, E+P,
							rattrap, RATTEMP);
else fprintf(fo,"%d %d trigger1 set %s start %d %d ;\n",E,T+20,sQl,E+P,E+P+1);

fprintf(fo,"%d %d notegroup1 set",E,T+20);
	for (j=0; j<i; j++) fprintf(fo," %d ",Mcod[j]);
	fprintf(fo,";\n");

/*
fprintf(fo,"%d %d trigger95 set %s start %d %d ;\n",E,T+50,sQl,E+P,E+P+1);
	P = 10;
fprintf(fo,"%d %d trigger95 start ;\n",E,T+50);
*/
fprintf(fo,"%d %d print (%d) ;\n",E,T+50,E);
if (recordit) fprintf(fo,"%d %d play clav %d 100 ;\n",E,T+70,E);
fprintf(fo,"%d %d foo (%d) ;\n",E,T+70,E);

/* load a function table (plaque is funpla; name is funname) */
	if (funpla)
		{
	fprintf(fo,"%d %d 4x ldfun %s %d 64K1 ;\n",E,T+200, funname, funpla);
		funpla = 0;
		}
	P = 10;
	}

else if (nstr[0] == 'R') fscanf(fi, "%d", &rattrap);
else if (nstr[0] == 'x')
	{
fprintf(fo,"\n%d 0%d000 notegroup1 stop ;\n",E+10,E+10);
fprintf(fo,"%d 0%d000 4x reset ;\n",E+10,E+10);
if (sectionnum < 14)
	fprintf(fo,"%d 0%d qlist%d start 5 6 ;\n",E+10,1000*(E+10)+400,
		sectionnum+1);
else fprintf(fo,"%d 0%d print PAR JUPITER ;\n",E+10,1000*(E+10));
fprintf(fo,"\n%d %d foo bar ;\n",E+15,1000*(E+15));
	break;
	}

	} /* end of FOREVER */
fclose (fi);
fclose (fo);
}

hate(s)
 char *s;
{
	fprintf(stderr, "%s\n", s);
}
