#include <stdio.h>
FILE *infile, *fopen();
float atof();

float getnum()
{
	float x;
	if (fscanf(infile, "%f", &x) < 1)
	{
		fprintf(stderr, "bad number\n");
		exit(1);
	}
	return (x);
}

main(argc, argv)
 char **argv;
{
	char string[100];
	if (argc > 1)
	{
		if (! (infile = fopen(argv[1], "r")))
		{
			fprintf(stderr, "%s: can't open\n", argv[1]);
			exit(1);
		}
	}
	else infile = stdin;
	while (fscanf(infile, "%s",  string) == 1)
	{
		if (!strcmp(string, "E"))
		{
			float temps, number = getnum();
			float lastfin = getnum();
			while ((temps = getnum()) > 0)
			{
				float fin = getnum();
				int inc = 0xffffff & 
					(int) ((0x100*(fin - lastfin)/temps));
				printf("inc[%d] %x fin[%d] %x\n",
					(int)number,
					inc,
					(int)number,
					(int)(0x7fffff * fin));
				lastfin = fin;
			}
		}
		else fprintf(stderr, "%s: unknown\n", string);
	}
}
			
